Program mandel; uses dos;
{Mnozh. Mandel`brota.
  Zamech.: krupnye puzyri na glavnom puzyre obrazujut serii; vidno, chto
  vozle kazhdogo est` zvesdoobraz. razvetvl.; chislo luchej v glavn. serii
  narastaet - 3,4,5,6,... . Pri etom puzyr`u na osi simmetrii mozhno
  uslovno pripis. indeks 2 - togda on lozhitsq v dannuju seriju. Dalee,
  mezhdu puzyrqmi osnovnoj serii primerno poseredine est` puzyri pomen`she,
  no krupnejshie v promezhutkakh mezhdu puzyrqmi glavnoj serii; chislo luchej
  v zv@zdah wozle nih = summe chisel luchej okruzhajushchikh puzyrej glavn. 
  serii! W promezhutkakh - puzyri eshcho <; snova chislo luchej =
  summe chisla luchej sosedej, i t.d. Skhematicheski:
  2                 3         4       5     6   ...
            5             7       9      
       7        8
     9
   11 
     Na puzyre 2 situaciq analogichna.
     Na puzyrqh glavn. serii: tozhe obleplqjushchie ikh puzyri obrazujut
serii, no zv@zdy vozle nikh imejut odno i to zhe chislo luchej; pri perekhode
k bol`shim nomeram glavnykh serij na etikh puzyrqh vmesto uvelichenija
chisla luchej proiskhodit ikh zakruchivanie (v razn. storony na raznykh
storonakh puzyrq glavnoj serii). Eto pozvolqet najti "svastiku".
     Pri starte iz tochki =/= 0+0*i kartinka iskazhaetsq, stanovitsq
qwno menee krasivoj; poqwlqetsq neodnoswqznost`.
}

 {$i uses_gra.pas}

 var nmax:integer;
 var i,j,color:integer; xc,yc,dx,dy,x0,x1,x,y0,y1,y:real;
 var n,m:integer;
 var e1:ekr;
 var n_ramk:integer;

 procedure obrab_predely; var r:real;
 begin
  if x1<=x0 then begin writeln(x0:10:4,x1:10:4,' !!!'); halt; end;
  if y1<=y0 then begin writeln(y0:10:4,y1:10:4,' !!!'); halt; end;
  dx:=x1-x0; dy:=y1-y0; r:=dy/dx;
  if abs(r-1)>0.01 then begin writeln('dx,dy=',dx:10:4,dy:10:4,' !!!'); halt; end;
  prisv_ekr(e1, 0,x_y,0,1, x0-dx/6,x1+dx/6,y0,y1,y0,y1,y0,y1);
 end;

 procedure ramk_; var i,m:integer;
 begin
  m:=n_ramk;
  for i:=0 to n_ramk do l(x0,y0+(y1-y0)*(i/m),x1,y0+(y1-y0)*(i/m),e1,getmaxcolor div 2);
  for i:=0 to n_ramk do l(x0+(x1-x0)*(i/m),y0,x0+(x1-x0)*(i/m),y1,e1,getmaxcolor div 2);
 end;

 procedure obrab(i,j:integer; rec,imc:real; var n:integer);
  var x,y,u,v:real; color:integer;
 begin
  rec:=(x0-dx/6)+(x1-x0)*(4/3)*(i/getmaxx);
  imc:=y1-(y1-y0)*(j/getmaxy);
  putpixel(i,j,getmaxcolor);
  n:=0;
  x:=0; y:=0; {nachal`n. tochka: z_0 = x+i*y = 0}
  {x:=0.1; y:=0.2;} {z_0 =/= 0 -> namnogo menee krasiwo}
  while (((x*x+y*y)<=4) and (n<=nmax)) do begin
   u:=sqr(x)-sqr(y)+rec; v:=2*x*y+imc;
   x:=u; y:=v; n:=n+1;
  end;
  if n>=nmax then n:=0; {chtoby samo mnozh. izobr. chorn.}
  {if n=0 then color:=0 else color:=round(getmaxcolor*ln(1.0*n)/ln(1.0*nmax));}
  color:=round(sqrt(sqrt(n/nmax))*getmaxcolor);
  if color>getmaxcolor then color:=getmaxcolor;
  putpixel(i,j,color);
 end;

  procedure show(x0e,x1e,y0e,y1e:real; nmaxe,n_ramke:integer; s:string);
  begin
   x0:=x0e; x1:=x1e; y0:=y0e; y1:=y1e;
   nmax:=nmaxe; n_ramk:=n_ramke;
   obrab_predely;
   write(x0:8:4,x1:8:4,y0:8:4,y1:8:4,' / ',nmax:5,' / ',s,chr($0D));
   ramk_;
   for i:=0 to getmaxx do if (i mod 50)=0 then begin
    for j:=0 to getmaxy do obrab(i,j,x,y,n);
   end;
   for i:=0 to getmaxx do if ((i mod 50)<>0) and ((i mod 10)=0) then begin
    for j:=0 to getmaxy do obrab(i,j,x,y,n);
   end;
   for i:=0 to getmaxx do if ((i mod 10)<>0) and ((i mod 2)=0) then begin
    for j:=0 to getmaxy do obrab(i,j,x,y,n);
   end;
   for i:=0 to getmaxx do if ((i mod 2)<>0) then begin
    for j:=0 to getmaxy do obrab(i,j,x,y,n);
   end;
   readln;
   write(x0:8:4,x1:8:4,y0:8:4,y1:8:4,' / ',nmax:5,' / ',s,chr($0D));
   ramk_;
  end;

 Begin
  {initgraph_62; b_w_5D;}
  initgraph_12; b_w_12;
(*
  show(-2,2,-2,2, 50,8, 'obzor');
  show(-0.1,0.1,0.8,1, 50,20, 'dlq z0=0.1+0.2*i');
  show(0,1,0,1, 50,10, 'puzyri 3,4,5,6,...');
  show(0.2,0.4,0.4,0.6, 50,10, 'puzyr` 4');
*)
  show(0.34,0.36,0.5,0.52, 50,20, 'p.4 - swastika');
(*
  show(0.3,0.34,0.46,0.5, 100,4, 'p.4 - e]@ 3 swastiki-spirali');
  show(0.3,0.4,0.45,0.55, 100,10, 'p.4 - ...');
  show(0.345,0.355,0.505,0.515, 100,10, 'p.4 - ...');
  show(0.32,0.33,0.485,0.495, 100,10, 'p.4 - ...');
  show(0.3,0.31,0.48,0.49, 100,10, 'p.4 - ...');
  show(0.29,0.3,0.48,0.49, 100,10, 'p.4 - ...');
  show(0.3,0.7,0.0,0.4, 100,4, 'p.5,6,7,...');
  show(0.37,0.47,0.16,0.26, 100,10, 'p.6');
  show(0.3,0.4,0.0,0.1, 100,10, '...');
  show(0.34,0.36,0.06,0.08, 100,20, 'p.9');
  show(-1.5,-1,-0.1,0.4, 1000,5, 'p.2 i sledujushch.');
  show(-2,-1.5,-0.1,0.4, 1000,5, 'p.2 i sledujushch.');
  show(-1.79,-1.75,-0.02,0.02, 1000,4, 'p.2 i sledujushch. - umen`sh. grusha');
  show(-1.5,-1.3,0,0.2, 100,20, '...');
*)
  readln; closegraph;
 End.
